/*
 *  This file is part of x48, an emulator of the HP-48sx Calculator.
 *  Copyright (C) 1994  Eddie C. Dost  (ecd@dressler.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Log: small.h,v $
 * Revision 1.2  1994/10/06  16:28:03  ecd
 * changed char to unsigned
 *
 * Revision 1.1  1994/09/13  15:05:11  ecd
 * Initial revision
 *
 *
 * $Id: small.h,v 1.2 1994/10/06 16:28:03 ecd Exp ecd $
 */

#define slash_width 3
#define slash_height 7
static unsigned char slash_bits[] = {
   0x04, 0x04, 0x02, 0x02, 0x02, 0x01, 0x01};

#define D_width 5
#define D_height 7
static unsigned char D_bits[] = {
   0x0f, 0x11, 0x11, 0x11, 0x11, 0x11, 0x0f};

#define I_width 1
#define I_height 7
static unsigned char I_bits[] = {
   0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01};

#define L_width 4
#define L_height 7
static unsigned char L_bits[] = {
   0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x0f};

#define Z_width 5
#define Z_height 7
static unsigned char Z_bits[] = {
   0x1f, 0x10, 0x08, 0x04, 0x02, 0x01, 0x1f};

#define arrow_width 7
#define arrow_height 7
static unsigned char arrow_bits[] = {
   0x00, 0x08, 0x18, 0x3f, 0x18, 0x08, 0x00};

#define diff_width 5
#define diff_height 7
static unsigned char diff_bits[] = {
   0x0e, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x0e};

#define integral_width 5
#define integral_height 8
static unsigned char integral_bits[] = {
   0x0c, 0x12, 0x02, 0x04, 0x04, 0x08, 0x09, 0x06};

#define sigma_width 6
#define sigma_height 9
static unsigned char sigma_bits[] = {
   0x3f, 0x21, 0x02, 0x04, 0x08, 0x04, 0x02, 0x21, 0x3f};

#define sqr_width 11
#define sqr_height 10
static unsigned char sqr_bits[] = {
   0x00, 0x03, 0x80, 0x04, 0x00, 0x04, 0x00, 0x02, 0x26, 0x01, 0x94, 0x07,
   0x08, 0x00, 0x14, 0x00, 0x53, 0x00, 0x21, 0x00};

#define root_width 18
#define root_height 13
static unsigned char root_bits[] = {
   0x26, 0x00, 0x00, 0x14, 0x00, 0x00, 0x08, 0xfe, 0x03, 0x14, 0x02, 0x02,
   0x53, 0x02, 0x00, 0x21, 0x99, 0x00, 0x00, 0x91, 0x00, 0x10, 0x91, 0x00,
   0xa0, 0x50, 0x00, 0xc0, 0x60, 0x00, 0x80, 0x20, 0x00, 0x00, 0x14, 0x00,
   0x00, 0x0c, 0x00};

#define pow10_width 13
#define pow10_height 9
static unsigned char pow10_bits[] = {
   0x00, 0x12, 0x00, 0x0c, 0x32, 0x04, 0x4b, 0x0a, 0x4a, 0x09, 0x4a, 0x00,
   0x4a, 0x00, 0x4a, 0x00, 0x32, 0x00};

#define exp_width 11
#define exp_height 9
static unsigned char exp_bits[] = {
   0x80, 0x04, 0x00, 0x03, 0x00, 0x01, 0x8c, 0x02, 0x52, 0x02, 0x09, 0x00,
   0x07, 0x00, 0x21, 0x00, 0x1e, 0x00};

#define under_width 6
#define under_height 7
static unsigned char under_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f};

#define prog_width 16
#define prog_height 7
static unsigned char prog_bits[] = {
   0x48, 0x12, 0x24, 0x24, 0x12, 0x48, 0x09, 0x90, 0x12, 0x48, 0x24, 0x24,
   0x48, 0x12};

#define string_width 10
#define string_height 7
static unsigned char string_bits[] = {
   0x85, 0x02, 0x85, 0x02, 0x85, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00};

#define equal_width 5
#define equal_height 7
static unsigned char equal_bits[] = {
   0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00};

#define nl_width 8
#define nl_height 7
static unsigned char nl_bits[] = {
   0x00, 0x84, 0x86, 0xff, 0x06, 0x04, 0x00};

#define pi_width 6
#define pi_height 7
static unsigned char pi_bits[] = {
   0x20, 0x1f, 0x12, 0x12, 0x12, 0x12, 0x12};

#define angle_width 8
#define angle_height 7
static unsigned char angle_bits[] = {
   0x40, 0x20, 0x10, 0x28, 0x44, 0x42, 0xff};

#define lbracket_width 5
#define lbracket_height 7
static unsigned char lbracket_bits[] = {
   0x18, 0x04, 0x04, 0x02, 0x04, 0x04, 0x18};

#define rbracket_width 5
#define rbracket_height 7
static unsigned char rbracket_bits[] = {
   0x03, 0x04, 0x04, 0x08, 0x04, 0x04, 0x03};

typedef struct letter_t {
  int            w, h;
  unsigned char *bits;
} letter_t;

letter_t small_font[] = {
  { 0, 0, 0 },	/* # 0 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },	/* # 16 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },	/* # 32 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { slash_width, slash_height, slash_bits },
  { 0, 0, 0 },	/* # 48 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { equal_width, equal_height, equal_bits },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },	/* # 64 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { D_width, D_height, D_bits },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { I_width, I_height, I_bits },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { L_width, L_height, L_bits },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },	/* # 80 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { Z_width, Z_height, Z_bits },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { under_width, under_height, under_bits },
  { 0, 0, 0 },	/* # 96 */
  { arrow_width, arrow_height, arrow_bits },		/* a == left arrow   */
  { diff_width, diff_height, diff_bits },		/* b == differential */
  { integral_width, integral_height, integral_bits },	/* c == integral */
  { sigma_width, sigma_height, sigma_bits },		/* d == sigma */
  { sqr_width, sqr_height, sqr_bits },			/* e == sqr */
  { root_width, root_height, root_bits },		/* f == root */
  { pow10_width, pow10_height, pow10_bits },		/* g == pow10 */
  { exp_width, exp_height, exp_bits },			/* h == exp */
  { prog_width, prog_height, prog_bits },		/* i == << >> */
  { string_width, string_height, string_bits },		/* j == " " */
  { nl_width, nl_height, nl_bits },			/* k == New Line */
  { pi_width, pi_height, pi_bits },			/* l == pi */
  { angle_width, angle_height, angle_bits },		/* m == angle */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },	/* # 112 */
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { 0, 0, 0 },
  { lbracket_width, lbracket_height, lbracket_bits },
  { 0, 0, 0 },
  { rbracket_width, rbracket_height, rbracket_bits },
  { 0, 0, 0 },
  { 0, 0, 0 }
};

